Index: /trunk/src/sh_tools.c
===================================================================
--- /trunk/src/sh_tools.c	(revision 584)
+++ /trunk/src/sh_tools.c	(revision 1)
@@ -1488,8 +943,7 @@
 #endif
 
-void put_header (unsigned char * head, const int protocol, 
+void put_header (unsigned char * head, int protocol, 
 		 unsigned long * length, char * u)
 {
-  unsigned char probe = probe_header_set(protocol);
 
   /* static long transfer_limit = (8 * SH_BUFSIZE); V0.8 */
@@ -1498,5 +952,5 @@
   SL_ENTER(_("put_header"));
 
-  head[0]   = protocol|probe;
+  head[0]   = protocol;
 
   ASSERT((*length < transfer_limit), _("*length < transfer_limit"))
@@ -1524,4 +978,5 @@
   SL_RET0(_("put_header"));
 }
+#endif
 
 /* ------------------------------------------
@@ -1538,10 +993,13 @@
  * (msg_size = payload_size - key_len = payload_size - 48)
  */ 
-
-/* 
- * only SH_V2_FULLSIZE is used, and only once
- */
-
+#ifdef SH_WITH_SERVER
+#define SH_V2_FULLSIZE  240
+#define SH_V2_PAYLOAD   224
+#define SH_V2_MESSAGE   176
+#else
 #define SH_V2_FULLSIZE 1024
+#define SH_V2_PAYLOAD  1008
+#define SH_V2_MESSAGE   960
+#endif
 
 #ifdef SH_ENCRYPT
@@ -1577,8 +1035,8 @@
       SH_IS_ASCII(head[5]) && isalpha(head[5]) &&			   
       SH_IS_ASCII(head[6]) && isalpha(head[6])) {
-    fprintf(stderr, _("%c %3o %s %5d  %c  %c  %c  %c\n"), sign,
+    fprintf(stderr, "%c %3o %s %5d  %c  %c  %c  %c\n", sign,
 	    head[0], code, msg_size, head[3], head[4], head[5], head[6]); 
   } else {
-    fprintf(stderr, _("%c %3o %s %5d %2X %2X %2X %2X\n"), sign,
+    fprintf(stderr, "%c %3o %s %5d %2X %2X %2X %2X\n", sign,
 	    head[0], code, msg_size, head[3], head[4], head[5], head[6]); 
   }
@@ -1587,5 +1045,4 @@
 
 #ifdef SH_ENCRYPT
-
 /*
  * #define DEBUG_EN2
@@ -1594,29 +1051,25 @@
  * last 4 bytes of outgoing header are set to dummy value
  */
-char * sh_tools_makePack (unsigned char * header, int flag,
-			  char * payload, unsigned long payload_size,
+char * sh_tools_makePack (unsigned char * header, 
+			  char * payload, int payload_size,
 			  keyInstance * keyInstE)
 {
-  BYTE            inBlock[B_SIZ]; 
-  BYTE            outBlock[B_SIZ];
-  char            ivBlock[B_SIZ];
-
-  UINT32          rpad[3];
+  UINT32 rpad[3];
   unsigned char   head[16];
-  double          epad;
-  unsigned long   i_epad = 0;
-  unsigned long   i_blk = payload_size / 16;
-  unsigned long   i_blkmax = SH_V2_FULLSIZE / 16;
-  unsigned long   pads = 0;
-  size_t          full_size;
-  char          * full_ret;
-
-  unsigned char * p;
-  int             j;
-  cipherInstance  cipherInst;
-  int             err_num;
-  int             blkfac;
-  int             oflow = 0;
-  char expbuf[SH_ERRBUF_SIZE];
+  double epad;
+  int    i_epad = 0;
+  int    i_blk = payload_size / 16;
+  int    i_blkmax = SH_V2_FULLSIZE / 16;
+  int    pads = 0;
+  int    full_size;
+  char * full_ret;
+
+  char                  * p;
+  RIJ_BYTE                    inBlock[B_SIZ]; 
+  RIJ_BYTE                    outBlock[B_SIZ];
+  int                     j;
+  cipherInstance          cipherInst;
+  int                     err_num;
+  int                     blkfac;
 
   /* 
@@ -1624,13 +1077,19 @@
   */
   if ((i_blk * 16) != payload_size) ++i_blk;
-
+#ifdef DEBUG_EN2
+  fprintf(stderr, "SEND <%d> blocks <%d>\n", payload_size, i_blk);
+#endif
   /* random_pad
    */
-  rpad[1] = taus_get ();
+  rpad[1] = taus_get (&(skey->rng0[0]), &(skey->rng1[0]), &(skey->rng2[0]));
   memcpy (head,      &rpad[1],    4);
-  rpad[0] = taus_get ();
+  rpad[0] = taus_get (&(skey->rng0[0]), &(skey->rng1[0]), &(skey->rng2[0]));
   memcpy (&head[4],  &rpad[0],    4);
-  rpad[2] = taus_get ();
+  rpad[2] = taus_get (&(skey->rng0[0]), &(skey->rng1[0]), &(skey->rng2[0]));
   memcpy (&head[8],  &rpad[2],    4);
+
+  /* protocol
+   */
+  /* memcpy (&head[8],  &header[3], 4); */
 
   /* size (payload)
@@ -1643,38 +1102,39 @@
   if (i_blk < i_blkmax) 
   {
-    pads   = i_blkmax - i_blk;
-    epad   = taus_get_double (&rpad);
-    i_epad = (unsigned long) (pads * epad);
+    pads = i_blkmax - i_blk;
+    /* memcpy((char *) &rpad[2], &head[12], 4); */
+    epad = taus_get_double (&rpad);
+#ifdef DEBUG_EN2
+    fprintf(stderr, "PAD1 <%d> <%f>\n", pads, epad);
+#endif
+    i_epad = (int) (pads * epad);
+#ifdef DEBUG_EN2
+    fprintf(stderr, "PAD2 <%d> <%d>\n", i_epad, (i_epad*16));
+#endif
   }
 
-  full_size =  16;                        /* head     */
-  if (sl_ok_muls(i_blk, 16) && sl_ok_adds(full_size, (i_blk*16)))
-    full_size =  full_size + (i_blk*16);  /* payload  */
-  else
-    oflow = 1;
-  if (sl_ok_adds(full_size, (i_epad*16)))
-    full_size =  full_size + (i_epad*16); /* pad      */
-  else
-    i_epad = 0;
-
-  if (oflow)
-    {
-      sh_error_handle((-1), FIL__, __LINE__, -1, MSG_E_SUBGEN,
-		      _("integer overflow"), 
-		      _("sh_tools_makePack"));
-    }
+  full_size = 
+  /* head     */ 16 + 
+  /* payload  */ (i_blk*16) + /* payload_size + */ 
+  /* pad      */ (i_epad * 16);
 
   full_ret = SH_ALLOC(full_size);
-
   memcpy(full_ret,                   head,    16);
-  if (payload != NULL && !oflow)
-    memcpy(&full_ret[16],              payload, payload_size);
-
-  if ((i_blk*16) > payload_size && !oflow) 
-    {
-      memset(&full_ret[16+payload_size], 0, (i_blk*16) - payload_size);
+  if (payload != NULL)
+    {
+      memcpy(&full_ret[16],              payload, payload_size);
+    }
+  if ((i_blk*16) > payload_size) 
+    {
+#ifdef DEBUG_EN2
+      fprintf(stderr, "SEN2 <%d>\n", (i_blk*16) - payload_size);
+#endif
+      memset(&full_ret[16+payload_size], '\0', (i_blk*16) - payload_size);
       payload_size = i_blk * 16;
     }
-  memset(&full_ret[16+payload_size], 0, i_epad*16);
+  memset(&full_ret[16+payload_size], '\0', i_epad*16);
+#ifdef DEBUG_EN2
+  fprintf(stderr, "SEN3 <%d> <%d>\n", full_size, i_epad*16);
+#endif
 
   /* rewrite header
@@ -1682,46 +1142,31 @@
   header[1]   = (unsigned int)(full_size/256);
   header[2]   = (unsigned int)(full_size - (256 * header[1]));
-
-  p      = (unsigned char *) full_ret; 
-  blkfac = full_size / B_SIZ;
-
-  err_num = rijndael_cipherInit (&cipherInst, MODE_CBC, NULL);
+  /* don't erase protocol from header 
+     memset(&header[3], '\0', 4);
+  */
+  p = full_ret; blkfac = full_size / 16;
+
+  err_num = cipherInit (&cipherInst, MODE_CBC, NULL);
   
-  if (err_num < 0) {
-    sh_error_handle((-1), FIL__, __LINE__, -1, MSG_E_SUBGEN,
-		    errorExplain(err_num, expbuf, sizeof(expbuf)), 
-		    _("sh_tools_makePack: rijndael_cipherInit")); }
-
-  if (probe_ok(flag)) {
-    memcpy(inBlock, p, B_SIZ);
-    err_num = rijndael_blockEncrypt(&cipherInst, keyInstE, 
-				    inBlock, 128, outBlock);
-    if (err_num >= 0) {
-      memcpy(p, outBlock, B_SIZ); p += B_SIZ;
-      memcpy(ivBlock, outBlock, sizeof(ivBlock));
-      err_num = rijndael_cipherInit (&cipherInst, MODE_CBC, ivBlock);
-      if (err_num >= 0) {
-	err_num = rijndael_blockEncrypt(&cipherInst, keyInstE, 
-					p, 128*(blkfac-1), p);
-      }
-    }
-  }
-
-  else {
-    for (j = 0; j < blkfac; ++j) {
+  if (err_num < 0) 
+    {
+      sh_error_handle((-1), FIL__, __LINE__, -1, MSG_E_SUBGEN,
+		      errorExplain(err_num), 
+		      _("sh_tools_makePack: cipherInit"));
+    }
+  for (j = 0; j < blkfac; ++j)
+    {
       memcpy(inBlock, p, B_SIZ);
-      err_num = rijndael_blockEncrypt(&cipherInst, keyInstE, 
-				      inBlock, 128, outBlock);
-      
-      if (err_num < 0) {
-	sh_error_handle((-1), FIL__, __LINE__, -1, MSG_E_SUBGEN,
-			errorExplain(err_num, expbuf, sizeof(expbuf)), 
-			_("sh_tools_makePack: rijndael_blockEncrypt"));
-	break; }
-      
+      err_num = blockEncrypt(&cipherInst, keyInstE, 
+			     inBlock, 128 * BNUM, outBlock);
+      if (err_num < 0)
+	{
+	  sh_error_handle((-1), FIL__, __LINE__, -1, MSG_E_SUBGEN,
+			  errorExplain(err_num), 
+			  _("sh_tools_makePack: blockEncrypt"));
+	}
       memcpy(p, outBlock, B_SIZ);
       p += B_SIZ;
     }
-  }
 
   return full_ret;
@@ -1731,68 +1176,55 @@
  * last 4 bytes of incoming header are dummy
  */
-char * sh_tools_revertPack (unsigned char * header, int flag, char * message, 
+char * sh_tools_revertPack (unsigned char * header, char * message, 
 			    keyInstance * keyInstD,
 			    unsigned long message_size)
 {
-  BYTE                    inBlock[B_SIZ]; 
-  BYTE                    outBlock[B_SIZ];
-  char                    ivBlock[B_SIZ];
   unsigned long   msg_size;
   char          * msg_ret;
 
-  unsigned char         * p;
+  char                  * p;
+  RIJ_BYTE                    inBlock[B_SIZ]; 
+  RIJ_BYTE                    outBlock[B_SIZ];
   int                     j;
   cipherInstance          cipherInst;
   int                     err_num;
   int                     blkfac;
-  char expbuf[SH_ERRBUF_SIZE];
 
   msg_size = (256 * (unsigned int)header[1] + (unsigned int)header[2]);
-  if (msg_size > message_size) 
+#ifdef DEBUG_EN2
+  fprintf(stderr, "RECV <%lu>\n", msg_size);
+#endif
+  if (msg_size > message_size) {
     msg_size = message_size;
-
-  p = (unsigned char *) message; blkfac = msg_size / 16;
-
-  err_num = rijndael_cipherInit (&cipherInst, MODE_CBC, NULL);
+#ifdef DEBUG_EN2
+    fprintf(stderr, "RECV TRUNC1 <%lu>\n", msg_size);
+#endif
+  }
+
+  p = message; blkfac = msg_size / 16;
+
+  err_num = cipherInit (&cipherInst, MODE_CBC, NULL);
   
   if (err_num < 0) 
     {
       sh_error_handle((-1), FIL__, __LINE__, -1, MSG_E_SUBGEN,
-		      errorExplain(err_num, expbuf, sizeof(expbuf)), 
-		      _("sh_tools_revertPack: rijndael_cipherInit"));
-    }
-
-  if (probe_ok(flag)) {
-    memcpy(inBlock, p, B_SIZ);
-    err_num = rijndael_blockDecrypt(&cipherInst, keyInstD, 
-				    inBlock, 128, outBlock);
-    if (err_num >= 0) {
-      memcpy(p, outBlock, B_SIZ); p += B_SIZ;
-      memcpy(ivBlock, inBlock, sizeof(ivBlock));
-      err_num = rijndael_cipherInit (&cipherInst, MODE_CBC, ivBlock);
-      if (err_num >= 0) {
-	err_num = rijndael_blockDecrypt(&cipherInst, keyInstD, 
-					p, 128*(blkfac-1), p);
-      }
-    }
-  }
-
-  else {
-    for (j = 0; j < blkfac; ++j) {
+		      errorExplain(err_num), 
+		      _("sh_tools_revertPack: cipherInit"));
+    }
+  for (j = 0; j < blkfac; ++j)
+    {
       memcpy(inBlock, p, B_SIZ);
-      err_num = rijndael_blockDecrypt(&cipherInst, keyInstD, 
-				      inBlock, 128, outBlock);
-  
-      if (err_num < 0) {
-	sh_error_handle((-1), FIL__, __LINE__, -1, MSG_E_SUBGEN,
-			errorExplain(err_num, expbuf, sizeof(expbuf)), 
-			_("sh_tools_revertPack: rijndael_blockDecrypt"));
-	break; }
-      
+      err_num = blockDecrypt(&cipherInst, keyInstD, 
+			     inBlock, 128 * BNUM, outBlock);
+      if (err_num < 0)
+	{
+	  sh_error_handle((-1), FIL__, __LINE__, -1, MSG_E_SUBGEN,
+			  errorExplain(err_num), 
+			  _("sh_tools_revertPack: blockDecrypt"));
+	}
       memcpy(p, outBlock, B_SIZ);
       p += B_SIZ;
     }
-  }
-
+  
   /* rewrite size in header
    */
@@ -1806,5 +1238,14 @@
       header[1]   = (unsigned int)(msg_size/256);
       header[2]   = (unsigned int)(msg_size - (256 * header[1]));
-    }
+#ifdef DEBUG_EN2
+      fprintf(stderr, "RECV TRUNC2 <%lu>\n", msg_size);
+#endif
+    }
+#ifdef DEBUG_EN2
+  fprintf(stderr, "REC2 <%lu>\n", msg_size);
+#endif
+  /* protocol
+   */
+  /* memcpy(&header[3], &message[8], 4); */
 
   /* payload 
@@ -1812,20 +1253,24 @@
   msg_ret = SH_ALLOC(msg_size+1);
   if (msg_size > 0)
-    memcpy(msg_ret, &message[16], msg_size);
+    {
+      memcpy(msg_ret, &message[16], msg_size);
+    }
   msg_ret[msg_size] = '\0';
-
+#ifdef DEBUG_EN2
+  fprintf(stderr, "REC3 <%lu>\n", msg_size);
+#endif
   SH_FREE(message);
+
   return msg_ret;
 }
-#endif /* #ifdef SH_ENCRYPT */
+#endif
 
 int sh_tools_hash_add(char * key, char * buf, int buflen)
 {
   char         * theSig;
-  char sigbuf[KEYBUF_SIZE];
 
   SL_ENTER(_("sh_tools_hash_add"));
 
-  theSig = sh_util_siggen (key, buf, buflen, sigbuf, sizeof(sigbuf));
+  theSig = sh_util_siggen (key, buf, buflen);
   sl_strlcat(buf, theSig, buflen + KEY_LEN + 1);
       
@@ -1841,9 +1286,8 @@
   register int   i;
   char         * theSig;
-  char sigbuf[KEYBUF_SIZE];
 
   SL_ENTER(_("sh_tools_hash_vfy"));
 
-  theSig = sh_util_siggen (key, buf, buflen, sigbuf, sizeof(sigbuf));
+  theSig = sh_util_siggen (key, buf, buflen);
   sl_strlcpy(hash, theSig, KEY_LEN+1);
 
@@ -1856,7 +1300,4 @@
   SL_RETURN((1), _("sh_tools_hash_vfy"));
 }
-
-#endif /* defined(SH_WITH_CLIENT) || defined(SH_WITH_SERVER) */
-
 
 /* ------------------------------------------ */
@@ -1869,9 +1310,8 @@
 {
   char           hash[KEY_LEN+1];
-  char         * temp = NULL;
+  char         * temp;
   register int   i;
   int            total = 0;
   char         * theSig;
-  char sigbuf[KEYBUF_SIZE];
 
 
@@ -1887,30 +1327,22 @@
   ASSERT_RET((buflen >= 0), _("buflen >= 0"), (NULL));
 
-  theSig = sh_util_siggen (key, buf, buflen, sigbuf, sizeof(sigbuf));
+  theSig = sh_util_siggen (key, buf, buflen);
   sl_strlcpy(hash, theSig, KEY_LEN+1);
 
-  if (sl_ok_adds(buflen, KEY_LEN))
-    {
-      total = KEY_LEN + buflen;
-      temp  = SH_ALLOC (total);
-
-      for (i = 0; i < KEY_LEN; ++i)
-	temp[i] = hash[i];
-
-      for (i = 0; i < buflen; ++i)
-	temp[i+KEY_LEN] = buf[i];
-    }
-  else
-    {
-      sh_error_handle((-1), FIL__, __LINE__, -1, MSG_E_SUBGEN,
-		      _("integer overflow"), 
-		      _("hash_me"));
-      temp = sh_util_strdup(buf);
-    }
+
+  total = KEY_LEN + buflen;
+  temp  = SH_ALLOC (total);
+
+  for (i = 0; i < KEY_LEN; ++i)
+    temp[i] = hash[i];
+
+  for (i = 0; i < buflen; ++i)
+    temp[i+KEY_LEN] = buf[i];
+
   SL_RETURN(temp, _("hash_me"));
 }
 #endif
 
-#if defined(SH_WITH_CLIENT) || defined(SH_WITH_SERVER)
+#if defined (SH_WITH_CLIENT)
 
 /* verify the checksum of a buffer; checksum comes first
@@ -1922,5 +1354,4 @@
   register int   i;
   char         * theSig;
-  char sigbuf[KEYBUF_SIZE];
 
   SL_ENTER(_("hash_check"));
@@ -1930,6 +1361,5 @@
 	  (key == NULL) ? "NULL" : key, buflen);
 #endif
-  theSig = sh_util_siggen (key, &buf[KEY_LEN], buflen-KEY_LEN,
-			   sigbuf, sizeof(sigbuf));
+  theSig = sh_util_siggen (key, &buf[KEY_LEN], buflen-KEY_LEN);
   sl_strlcpy(hash, theSig, KEY_LEN+1);
       
@@ -1946,8 +1376,8 @@
 #if defined (SH_WITH_SERVER)
 
-char * get_client_conf_file (const char * peer, unsigned long * length)
+char * get_client_conf_file (char * peer, unsigned long * length)
 {
   char * ret;
-  int    status;
+  int    size, status;
   struct stat buf;
   char * base;
@@ -1955,10 +1385,18 @@
   SL_ENTER(_("get_client_conf_file"));
 
-  base = sh_util_strdup(DEFAULT_DATAROOT);
-  ret = sh_util_strconcat(base, _("/rc."), peer, NULL);
-  if (!ret) 
-    { SH_FREE(base); *length = 0; SL_RETURN(NULL, _("get_client_conf_file")); }
-
+  size = sl_strlen(DEFAULT_DATAROOT);
+  base = SH_ALLOC(size + 1);
+  sl_strlcpy(base, DEFAULT_DATAROOT, size + 1); 
+
+  size = sl_strlen(base) + sl_strlen(peer) + 5;
+  ++size;
+
+  ret = SH_ALLOC(size);
+  sl_strlcpy(ret, base, size);
+  sl_strlcat(ret, _("/rc."), size);
+  sl_strlcat(ret, peer, size);
+  
   status = retry_stat (FIL__, __LINE__, ret, &buf);
+
   if (status == 0)
     goto lab_end;
@@ -1967,9 +1405,9 @@
 		    (long) sh.effective.uid, ret);
 
-  SH_FREE(ret); ret = sh_util_strconcat(base, _("/rc"), NULL);
-  if (!ret) 
-    { SH_FREE(base); *length = 0; SL_RETURN(NULL, _("get_client_conf_file")); }
+  sl_strlcpy(ret, base, size);
+  sl_strlcat(ret, "/rc", size);
   
   status = retry_stat (FIL__, __LINE__, ret, &buf);
+
   if (status == 0)
     goto lab_end;
@@ -1978,5 +1416,6 @@
 		    (long) sh.effective.uid, ret);
 
-  SH_FREE(base); SH_FREE(ret); *length=0;
+  SH_FREE(base);
+  *length=0;
   SL_RETURN(NULL, _("get_client_conf_file"));
 
@@ -1986,27 +1425,37 @@
       sh_error_handle(SH_ERR_ERR, FIL__, __LINE__, status, MSG_E_SUBGEN,
 		    _("File too large"), _("get_client_conf_file"));
-      SH_FREE(base); SH_FREE(ret); *length = 0;
+      SH_FREE(base);
       SL_RETURN(NULL, _("get_client_conf_file"));
     }
-
-  SH_FREE(base); *length = (unsigned long) buf.st_size;
+  *length = (unsigned long) buf.st_size;
+  SH_FREE(base);
   SL_RETURN(ret, _("get_client_conf_file"));
 }
 
-char * get_client_data_file (const char * peer, unsigned long * length)
+char * get_client_data_file (char * peer, unsigned long * length)
 {
   char * ret;
-  int    status;
+  int    size, status;
   struct stat buf;
+
   char * base;
 
   SL_ENTER(_("get_client_data_file"));
 
-  base = sh_util_strdup(DEFAULT_DATAROOT);
-  ret = sh_util_strconcat(base, _("/file."), peer, NULL);
-  if (!ret) 
-    { SH_FREE(base); *length = 0; SL_RETURN(NULL, _("get_client_data_file")); }
-
+  size = sl_strlen(DEFAULT_DATAROOT);
+  base = SH_ALLOC(size + 1);
+  sl_strlcpy(base, DEFAULT_DATAROOT, size + 1); 
+
+  size = sl_strlen(base) + sl_strlen(peer) + 7;
+
+  ++size;
+
+  ret = SH_ALLOC(size);
+  sl_strlcpy(ret, base, size);
+  sl_strlcat(ret, _("/file."), size);
+  sl_strlcat(ret, peer, size);
+  
   status = retry_stat (FIL__, __LINE__, ret, &buf);
+
   if (status == 0)
     goto lab1_end;
@@ -2015,10 +1464,10 @@
 		    (long) sh.effective.uid, ret);
 
-  SH_FREE(ret); 
-  ret = sh_util_strconcat(base, _("/file"), NULL);
-  if (!ret) 
-    { SH_FREE(base); *length = 0; SL_RETURN(NULL, _("get_client_data_file")); }
-
+
+  sl_strlcpy(ret, base, size);
+  sl_strlcat(ret, _("/file"), size);
+  
   status = retry_stat (FIL__, __LINE__, ret, &buf);
+
   if (status == 0)
     goto lab1_end;
@@ -2027,5 +1476,7 @@
 		    (long) sh.effective.uid, ret);
 
-  *length = 0; SH_FREE(base); SH_FREE(ret);
+
+  *length = 0;
+  SH_FREE(base);
   SL_RETURN(NULL, _("get_client_data_file"));
 
@@ -2035,50 +1486,15 @@
       sh_error_handle(SH_ERR_ERR, FIL__, __LINE__, status, MSG_E_SUBGEN,
 		    _("File too large"), _("get_client_data_file"));
-      SH_FREE(base); SH_FREE(ret); *length = 0;
+      SH_FREE(base);
       SL_RETURN(NULL, _("get_client_data_file"));
     }
-
-  *length = (unsigned long) buf.st_size; SH_FREE(base);
+  *length = (unsigned long) buf.st_size;
+  SH_FREE(base);
   SL_RETURN(ret, _("get_client_data_file"));
-}
-
-char * get_client_uuid_file (const char * peer, unsigned long * length, const char * uuid)
-{
-  char * ret;
-  int    status;
-  struct stat buf;
-  char * base;
-
-  SL_ENTER(_("get_client_uuid_file"));
-
-  base = sh_util_strdup(DEFAULT_DATAROOT);
-  ret = sh_util_strconcat(base, _("/file."), peer, ".", uuid, NULL);
-  SH_FREE(base);
-  if (!ret) 
-    { *length = 0; SL_RETURN(NULL, _("get_client_uuid_file")); }
-
-  status = retry_stat (FIL__, __LINE__, ret, &buf);
-  if (status != 0)
-    {
-      sh_error_handle(SH_ERR_ERR, FIL__, __LINE__, status, MSG_E_ACCESS,
-		      (long) sh.effective.uid, ret);
-      SH_FREE(ret); *length = 0;
-      SL_RETURN(NULL, _("get_client_uuid_file"));
-    }
-  else if (buf.st_size > 0x7fffffff)
-    {
-      sh_error_handle(SH_ERR_ERR, FIL__, __LINE__, status, MSG_E_SUBGEN,
-		    _("File too large"), _("get_client_uuid_file"));
-      SH_FREE(ret); *length = 0;
-      SL_RETURN(NULL, _("get_client_data_file"));
-    }
-
-  *length = (unsigned long) buf.st_size;
-  SL_RETURN(ret, _("get_client_uuid_file"));
-}
-
-#endif
-
-#if defined(SH_WITH_CLIENT) || defined(SH_WITH_SERVER) || defined(SH_STEALTH) || defined(WITH_SIG)
+  
+}
+#endif
+
+#if defined(SH_WITH_CLIENT) || defined(SH_STEALTH) || defined(WITH_GPG) || defined(WITH_PGP)
 
 /* --------- secure temporary file ------------ */
@@ -2093,15 +1509,21 @@
   int           status = BAD;
   char        * my_tmp_dir;
-  char hashbuf[KEYBUF_SIZE];
+  int           len;
 
   SL_ENTER(_("open_tmp"));
 
 #if defined(SH_TMPDIR)
-  my_tmp_dir = sh_util_strdup(SH_TMPDIR); 
+  len        = sl_strlen(SH_TMPDIR) + 1;
+  my_tmp_dir = SH_ALLOC(len);
+  sl_strlcpy(my_tmp_dir, SH_TMPDIR, len); 
 #else
 #if defined(SH_WITH_SERVER)
-  my_tmp_dir = sh_util_strdup(DEFAULT_LOGDIR); 
+  len        = sl_strlen(DEFAULT_LOGDIR) + 1;
+  my_tmp_dir = SH_ALLOC(len);
+  sl_strlcpy(my_tmp_dir, DEFAULT_LOGDIR, len); 
 #else
-  my_tmp_dir = sh_util_strdup(sh.effective.home);
+  len        = sl_strlen(sh.effective.home) + 1;
+  my_tmp_dir = SH_ALLOC(len);
+  sl_strlcpy(my_tmp_dir, sh.effective.home, len);
 #endif 
 #endif
@@ -2123,15 +1545,13 @@
     /* create random filename in effective users home directory
      */
-    ticks = taus_get ();
+    ticks = taus_get (&(skey->rng0[0]), &(skey->rng1[0]), &(skey->rng2[0]));
     if (my_tmp_dir[0] == '/' && my_tmp_dir[1] == '\0')
       file = sh_util_strconcat (my_tmp_dir, 
-				sh_tiger_hash( (char *) &ticks, TIGER_DATA, 4,
-					       hashbuf, sizeof(hashbuf)),
+				sh_tiger_hash( (char *) &ticks, TIGER_DATA, 4),
 				NULL);
     else
       file = sh_util_strconcat (my_tmp_dir, 
 				"/", 
-				sh_tiger_hash( (char *) &ticks, TIGER_DATA, 4,
-					       hashbuf, sizeof(hashbuf)),
+				sh_tiger_hash( (char *) &ticks, TIGER_DATA, 4),
 				NULL);
 
@@ -2148,6 +1568,4 @@
 	SH_FREE (file);
 	SH_FREE(my_tmp_dir);
-	sh_error_handle(SH_ERR_ALL, FIL__, __LINE__, status, MSG_E_SUBGEN, 
-			_("Error (lstat) while opening temporary file"), _("open_tmp"));
 	TPT(( 0, FIL__, __LINE__, _("msg=<Unexpected error %d>\n"), error));
 	SL_RETURN((-1), _("open_tmp"));
@@ -2175,12 +1593,13 @@
   } while (status == BAD);
 
-  fd = sl_open_safe_rdwr (FIL__, __LINE__, file, SL_YESPRIV);
+  fd = sl_open_safe_rdwr (file, SL_YESPRIV);
   if (SL_ISERROR(fd))
     {
-      sh_error_handle((-1), FIL__, __LINE__, fd, MSG_E_SUBGEN, 
+      sh_error_handle(SH_ERR_ALL, FIL__, __LINE__, fd, MSG_E_SUBGEN, 
 		      _("Error opening temporary file"), _("open_tmp"));
       TPT(( 0, FIL__, __LINE__, _("msg=<Error %d temporary file %s>\n"), 
 	    fd, file));
     }
+  
 
   SH_FREE (file);
@@ -2216,72 +1635,2 @@
 }
 #endif
-
-/********************************************************
- * Search rotated logfile
- */
-#include <unistd.h>
-#include <libgen.h>
-#include <dirent.h>
-
-char * sh_rotated_log_search(const char * path, struct stat * buf)
-{
-
-  size_t size;
-  int    i;
-  char * searchpath;
-  struct stat sbuf;
-  DIR  * dp;
-  char * dname;
-  char * bname;
-
-  dname  = sh_util_dirname(path);
-  bname  = sh_util_basename(path);
-
-  size = strlen(dname) + strlen(bname) + 4;
-  searchpath = SH_ALLOC(size);
-
-  for (i = 0; i < 2; ++i)
-    {
-      snprintf(searchpath, size, "%s/%s.%1d", dname, bname, i);
-      if (0 == stat(searchpath, &sbuf) && sbuf.st_ino == buf->st_ino)
-	{
-	  SH_FREE(dname);
-	  SH_FREE(bname);
-	  return searchpath;
-	}
-    }
-
-  SH_FREE(searchpath);
-
-  if (NULL != (dp = opendir(dname)))
-    {
-      struct dirent * de;
-
-      while (NULL != (de = readdir(dp)))
-	{
-	  if (0 == strcmp(de->d_name, ".") || 0 == strcmp(de->d_name, ".."))
-	    continue;
-
-	  size = strlen(dname) + strlen(de->d_name) + 2;
-	  searchpath = SH_ALLOC(size);
-	  snprintf(searchpath, size, "%s/%s", dname, de->d_name);
-
-	  if (0 == stat(searchpath, &sbuf) && sbuf.st_ino == buf->st_ino)
-	    {
-	      SH_FREE(dname);
-	      SH_FREE(bname);
-	      closedir(dp);
-	      return searchpath;
-	    }
-	  
-	  SH_FREE(searchpath);
-	}
-      closedir(dp);
-    }
-
-  SH_FREE(dname);
-  SH_FREE(bname);
-
-  return NULL;
-}
-
